/**************************************************
  Winavr(AVR-GCC) C Compiler
  (C) 1998-2007 AVRMall, by Jong-Hyung Kim
  ATmega128 B/D V3.1 & M128K1 LCD functions
  
  www.avrmall.com 
***************************************************/
  
#include <avr/io.h>                                     

// type definitions.
typedef unsigned char UC;
typedef unsigned int  UI;

void delay_us(UI time_us)
{
	UI i;

	for(i=0; i<time_us; i++) // 4 cycle +
	{
		asm("PUSH R0"); // 2 cycle +
		asm("POP R0"); // 2 cycle +
		asm("PUSH R0"); // 2 cycle +
		asm("POP R0"); // 2 cycle + =12 cycle for 11.0592MHZ
		asm("PUSH R0"); // 2 cycle +
		asm("POP R0"); // 2 cycle = 16 cycle = 1us for 16MHz
	}
}

void delay_ms(UI time_ms)
{
	UI i;
    
	for(i=0; i<time_ms;i++)
    delay_us(1000);
}

void lcd_init(void)
{
	
	delay_ms(15);
	lcd_cmd(0x38);
	
	delay_ms(5);
	lcd_cmd(0x38);
	
	delay_us(200);
	lcd_cmd(0x38);
	delay_us(100);
	
	lcd_cmd(0x38);
	delay_us(100);
	
	lcd_display_on();

	lcd_clear();
	
	lcd_cmd(0x06);
	lcd_busy();
}

void lcd_data(char data)
{
	char *lcd_io;
	lcd_busy();	
	lcd_io = (char *) 0xc000; 
    *lcd_io = data;
}

void lcd_cmd(char cmd)
{
	char *lcd_io;
	lcd_busy();	
	lcd_io = (char *) 0x8000; 
    *lcd_io = cmd;
}

char lcd_read(char read)
{	
	char *lcd_io;
	lcd_io = (char *) 0x8000;
    read = *lcd_io;        	
	return(read);
}
void lcd_clear(void)
{
	lcd_busy();
    lcd_cmd(0x01);
    delay_us(100);
}

void lcd_display_on(void)
{
	lcd_busy();
	lcd_cmd(0x0c);
    delay_us(100);
}

void lcd_display_off(void)
{
	lcd_busy();
	lcd_cmd(0x08);
    delay_us(100);
}

void lcd_right_shift(void)
{
	lcd_busy();
    lcd_cmd(0x1c);
    delay_us(100);
}

void lcd_left_shift(void)
{
	lcd_busy();
    lcd_cmd(0x18);
    delay_us(100);
}

void lcd_busy(void)
{
	char lcd_status;
	while(lcd_read(lcd_status) & 0x80);
}

void lcd_ch(char ch)            
{
    char *lcd_io;
    lcd_busy();
    lcd_io = (char *) 0xc000; 
    *lcd_io = ch;
}

void lcd_str(char *str)         
{
 	unsigned char i = 0;
 	do{
		lcd_ch(str[i]) ;
   	}while(str[++i] != 0x00);	//null=0x00
}

void _lcd_str(char *str)
{
	unsigned char i = 0;
 	do{
		lcd_ch(str[i]) ;
   	}while(str[++i] != 0x00);	//null=0x00
}

void Gotoxy(unsigned char x, unsigned char y)	//x-  y |
{
    lcd_busy();
    switch(y)
    {
       case 0: lcd_cmd(0x80+x); break;  
       case 1: lcd_cmd(0xc0+x); break;
       case 2: lcd_cmd(0x94+x); break;
       case 3: lcd_cmd(0xd4+x); break;	
    }
	
}
